commit:     8c10803c08df9e014aa85998421a7dec065707e3
Author:     Ionen Wolkens <ionen <AT> gentoo <DOT> org>
AuthorDate: Mon Sep 25 08:32:56 2023 +0000
Commit:     Ionen Wolkens <ionen <AT> gentoo <DOT> org>
CommitDate: Mon Sep 25 09:36:23 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8c10803c

dev-games/godot: add 3.5.3

Signed-off-by: Ionen Wolkens <ionen <AT> gentoo.org>

 dev-games/godot/Manifest                      |   1 +
 dev-games/godot/files/godot-3.5.3-gcc13.patch |   9 ++
 dev-games/godot/godot-3.5.3.ebuild            | 222 ++++++++++++++++++++++++++
 3 files changed, 232 insertions(+)

diff --git a/dev-games/godot/Manifest b/dev-games/godot/Manifest
index 0aca862b9003..8d6e161ab361 100644
--- a/dev-games/godot/Manifest
+++ b/dev-games/godot/Manifest
@@ -1,3 +1,4 @@
 DIST godot-3.5.2-stable.tar.xz 24047432 BLAKE2B 
a4d600cb174b2f79cc91c583b1052db2e7e2921003ffd5a307a2484af9cc050b600e763b6016ba2df043ba5e492f0bdd13c207fd3a3d794b6602f7c574093cb0
 SHA512 
e9f3c8b23cd69422639fe22948fb1f5f2071dff6e013fee3c08d6d3c1f39de4dfc252d32eb395c847021c9bbc1b2fa320500140ff3e684bf00530889ba48a181
+DIST godot-3.5.3-stable.tar.xz 24072964 BLAKE2B 
a4c03328e3aa77d741a1c642cfd645de04084f2852e865757fc8960c4919d3b8b8571e772f44004901fdd80a967e8e21bd8c6be8b36263db7afae787dcbd3ed6
 SHA512 
4c008af5bb7c298d465edbe03f6ebc642f5bbbb0a4254e99d7a7a88919e1f9424b98c5dff95a55ae68d4e2e5878c7c0bb7d13a66869cb632ecb51a913f865155
 DIST godot-4.0.4-stable.tar.xz 30267060 BLAKE2B 
42f5f0c89edb96eb6f36c54229671f233ed0a49a769361195f9aaf807b45fe3968aeeaad204fc07e200114d852e4651f9dc8eb137c4f3aca7b8e8e1203ebcdc9
 SHA512 
4dadc123995d7262ffa6c5002d08611038957c59a8bd742284b9b62577de6b7182aad807db7a231180a355df0f25d10babdc914faf9287ed401152d98762bb5f
 DIST godot-4.1.1-stable.tar.xz 30681136 BLAKE2B 
18e6dae0428812493ecdd8d76cc99c2264873707d4abac0146a1d9b9cbffe2f678c346951a714d0d211fd380b433f910cc952e1720a2c4933febeb7d64283369
 SHA512 
9fc4bdff2ef3f5ad173514709591941f1dff32dd7cc54224a85691b34b6a5f1d01addc9b4f8d996bc6f774cee5c722181122a39b498b23e48e8d70629ff8ff0b

diff --git a/dev-games/godot/files/godot-3.5.3-gcc13.patch 
b/dev-games/godot/files/godot-3.5.3-gcc13.patch
new file mode 100644
index 000000000000..dd681b87dce5
--- /dev/null
+++ b/dev-games/godot/files/godot-3.5.3-gcc13.patch
@@ -0,0 +1,9 @@
+Issues seem(?) to only trigger when gcc13 is combined with musl.
+
+https://bugs.gentoo.org/906363
+--- a/modules/fbx/fbx_parser/FBXCommon.h
++++ b/modules/fbx/fbx_parser/FBXCommon.h
+@@ -78,2 +78,3 @@
+ 
++#include <cstdint>
+ #include <string>

diff --git a/dev-games/godot/godot-3.5.3.ebuild 
b/dev-games/godot/godot-3.5.3.ebuild
new file mode 100644
index 000000000000..52470f766d26
--- /dev/null
+++ b/dev-games/godot/godot-3.5.3.ebuild
@@ -0,0 +1,222 @@
+# Copyright 2022-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{10..11} )
+inherit bash-completion-r1 desktop python-any-r1 scons-utils toolchain-funcs 
xdg
+
+DESCRIPTION="Multi-platform 2D and 3D game engine with a feature-rich editor"
+HOMEPAGE="https://godotengine.org/";
+SRC_URI="
+       https://downloads.tuxfamily.org/godotengine/${PV}/${P}-stable.tar.xz
+       
https://github.com/godotengine/godot/releases/download/${PV}-stable/${P}-stable.tar.xz
+"
+S="${WORKDIR}/${P}-stable"
+
+LICENSE="
+       MIT
+       Apache-2.0 BSD Boost-1.0 CC0-1.0 Unlicense ZLIB
+       gui? ( CC-BY-4.0 ) tools? ( BitstreamVera OFL-1.1 )
+"
+SLOT="3"
+KEYWORDS="~amd64"
+# Enable roughly same as upstream by default so it works as expected,
+# except raycast (tools-only heavy dependency), and deprecated.
+IUSE="
+       +bullet debug deprecated +gui pulseaudio raycast +runner +theora
+       +tools +udev +upnp +webm +webp
+"
+
+# dlopen: alsa-lib,pulseaudio,udev
+RDEPEND="
+       app-arch/zstd:=
+       dev-games/recastnavigation:=
+       dev-libs/libpcre2:=[pcre32]
+       media-libs/alsa-lib
+       media-libs/freetype[brotli]
+       media-libs/libpng:=
+       <net-libs/mbedtls-3:=
+       net-libs/wslay
+       sys-libs/zlib:=
+       bullet? ( sci-physics/bullet:= )
+       gui? (
+               media-libs/libglvnd
+               x11-libs/libX11
+               x11-libs/libXcursor
+               x11-libs/libXext
+               x11-libs/libXi
+               x11-libs/libXinerama
+               x11-libs/libXrandr
+               x11-libs/libXrender
+               tools? ( raycast? ( media-libs/embree:3 ) )
+       )
+       pulseaudio? ( media-libs/libpulse )
+       theora? (
+               media-libs/libogg
+               media-libs/libtheora
+               media-libs/libvorbis
+       )
+       tools? ( app-misc/ca-certificates )
+       udev? ( virtual/udev )
+       upnp? ( net-libs/miniupnpc:= )
+       webm? (
+               media-libs/libvorbis
+               media-libs/libvpx:=
+               media-libs/opus
+       )
+       webp? ( media-libs/libwebp:= )
+"
+DEPEND="
+       ${RDEPEND}
+       gui? ( x11-base/xorg-proto )
+"
+BDEPEND="virtual/pkgconfig"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-3.5-musl.patch
+       "${FILESDIR}"/${PN}-3.5-scons.patch
+       "${FILESDIR}"/${PN}-3.5.3-gcc13.patch
+)
+
+src_prepare() {
+       default
+
+       sed -i "1,5s/ godot/&${SLOT}/i" misc/dist/linux/godot.6 || die
+       sed -i "/id/s/Godot/&${SLOT}/" 
misc/dist/linux/org.godotengine.Godot.appdata.xml || die
+       sed -e "s/=godot/&${SLOT}/" -e "/^Name=/s/$/ ${SLOT}/" \
+               -i misc/dist/linux/org.godotengine.Godot.desktop || die
+
+       sed -i "s|pkg-config |$(tc-getPKG_CONFIG) |" 
platform/{x11,server}/detect.py || die
+
+       # use of builtin_ switches can be messy (see below), delete to be sure
+       local unbundle=(
+               bullet embree freetype libogg libpng libtheora libvorbis libvpx
+               libwebp mbedtls miniupnpc opus pcre2 recastnavigation wslay 
zlib zstd
+               # certs: unused by generated header, but scons panics if not 
found
+       )
+       rm -r "${unbundle[@]/#/thirdparty/}" || die
+}
+
+src_compile() {
+       local -x BUILD_NAME=gentoo # replaces "custom_build" in version string
+
+       local esconsargs=(
+               AR="$(tc-getAR)" CC="$(tc-getCC)" CXX="$(tc-getCXX)"
+
+               platform=$(usex gui x11 server)
+               progress=no
+               verbose=yes
+
+               deprecated=$(usex deprecated)
+               #execinfo=$(usex !elibc_glibc) # libexecinfo is not packaged
+               minizip=yes # uses a modified bundled copy
+               pulseaudio=$(usex pulseaudio)
+               udev=$(usex udev)
+
+               system_certs_path="${EPREFIX}"/etc/ssl/certs/ca-certificates.crt
+
+               # platform/*/detect.py uses builtin_* switches to check if need
+               # to link with system libraries, but ignores whether the dep is
+               # actually used, so "enable" deleted builtins on disabled deps
+               builtin_bullet=$(usex !bullet)
+               builtin_certs=no
+               builtin_embree=$(usex !gui yes $(usex !tools yes $(usex 
!raycast)))
+               builtin_enet=yes # bundled copy is patched for IPv6+DTLS support
+               builtin_freetype=no
+               builtin_libogg=yes # unused
+               builtin_libpng=no
+               builtin_libtheora=$(usex !theora)
+               builtin_libvorbis=$(usex !theora $(usex !webm))
+               builtin_libvpx=$(usex !webm)
+               builtin_libwebp=$(usex !webp)
+               builtin_mbedtls=no
+               builtin_miniupnpc=$(usex !upnp)
+               builtin_opus=$(usex !webm)
+               builtin_pcre2=no
+               builtin_recast=no
+               builtin_rvo2=yes # bundled copy has godot-specific changes
+               builtin_squish=yes # ^ likewise, may not be safe to unbundle
+               builtin_wslay=no
+               builtin_xatlas=yes # not wired for unbundling nor packaged
+               builtin_zlib=no
+               builtin_zstd=no
+               # (more is bundled in third_party/ but they lack builtin_* 
switches)
+
+               # modules with optional dependencies, "possible" to disable 
more but
+               # gets messy and breaks all sorts of features (expected enabled)
+               module_bullet_enabled=$(usex bullet)
+               module_mono_enabled=no # unhandled
+               module_ogg_enabled=no # unused
+               module_opus_enabled=no # unused, support is gone and webm uses 
system's
+               # note raycast is disabled on many arches, see raycast/config.py
+               module_raycast_enabled=$(usex gui $(usex tools $(usex raycast)))
+               module_theora_enabled=$(usex theora)
+               module_upnp_enabled=$(usex upnp)
+               module_vorbis_enabled=no # unused, non-theora/webm uses 
stb_vorbis
+               module_webm_enabled=$(usex webm)
+               module_webp_enabled=$(usex webp)
+
+               # let *FLAGS handle these, e.g. can pass -flto as-is
+               debug_symbols=no
+               optimize=none
+               use_lto=no
+               use_static_cpp=no
+       )
+
+       if use runner && use tools; then
+               # build alternate faster + ~60% smaller binary for running
+               # games or servers without game development debug paths
+               escons extra_suffix=runner target=release tools=no 
"${esconsargs[@]}"
+       fi
+
+       esconsargs+=(
+               # debug: debug for godot itself
+               # release_debug: debug for game development
+               # release: no debugging paths, only available with tools=no
+               target=$(usex debug{,} $(usex tools release_debug release))
+               tools=$(usex tools)
+       )
+
+       escons extra_suffix=main "${esconsargs[@]}"
+}
+
+src_install() {
+       local s=godot${SLOT}
+
+       newbin bin/godot*.main ${s}
+       if use runner && use tools; then
+               newbin bin/godot*.runner ${s}-runner
+       else
+               # always available, revdeps shouldn't depend on [runner]
+               dosym ${s} /usr/bin/${s}-runner
+       fi
+
+       newman misc/dist/linux/godot.6 ${s}.6
+       dodoc AUTHORS.md CHANGELOG.md DONORS.md README.md
+
+       if use gui; then
+               newicon icon.svg ${s}.svg
+               newmenu misc/dist/linux/org.godotengine.Godot.desktop \
+                       org.godotengine.${s^}.desktop
+
+               insinto /usr/share/metainfo
+               newins misc/dist/linux/org.godotengine.Godot.appdata.xml \
+                       org.godotengine.${s^}.appdata.xml
+
+               insinto /usr/share/mime/application
+               newins misc/dist/linux/org.godotengine.Godot.xml \
+                       org.godotengine.${s^}.xml
+       fi
+
+       newbashcomp misc/dist/shell/godot.bash-completion ${s}
+       bashcomp_alias ${s}{,-runner}
+
+       insinto /usr/share/fish/vendor_completions.d
+       newins misc/dist/shell/godot.fish ${s}.fish
+       dosym ${s}.fish /usr/share/fish/vendor_completions.d/${s}-runner.fish
+
+       insinto /usr/share/zsh/site-functions
+       newins misc/dist/shell/_godot.zsh-completion _${s}
+       dosym _${s} /usr/share/zsh/site-functions/_${s}-runner
+}

Reply via email to